/* playlist
 *
 *      playlist builder for mikmodule
 *
 *      (c)2007 Scott Lawrence
 *         yorgle@gmail.com
 */

/*
 * Copyright (C) 2007 Scott Lawrence
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include "mikmod.h"

typedef struct playlist_item {
        char * filename;        /* /mods/u4ia/astro2.mod */
        char * shortname;       /* astro2.mod */
        MODULE * song;          /* NULL if not loaded */
        int maxpos;             /* maxlen for a pattern (or 64)*/
	long maxfreq;		/* max frequency */
        int playcount;          /* number of plays */
	int index;		/* order for playback */
	int loadIndex;		/* order in the file -- in order */
	long filesize;		/* for smart queueing */
        
        struct playlist_item * next;    /* next in the list */
	struct playlist_item * prev; 	/* prev in the list */
} PLAYLIST_ITEM;


char * playlist_lastslash( char * fn );

void playlist_delete_list( PLAYLIST_ITEM * itm );

PLAYLIST_ITEM * playlist_new_item( char * filename );
PLAYLIST_ITEM * playlist_add_to_list( PLAYLIST_ITEM * list, PLAYLIST_ITEM * i );
PLAYLIST_ITEM * playlist_shuffle( PLAYLIST_ITEM * list );
PLAYLIST_ITEM * playlist_load( char * filename );
PLAYLIST_ITEM * playlist_directory( char * dirname, int subdirs );


int playlist_count( PLAYLIST_ITEM * pi );
