/* scan - playlist scanning
 *
 *      (c)2007 Scott Lawrence
 *         yorgle@gmail.com
 */

/*
 * Copyright (C) 2007 Scott Lawrence
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#include <sys/types.h>  /* readdir(), is_dir */
#include <dirent.h>     /* readdir() */


/* just need to peek into the main handler for these... */
PzWindow * mikmodule_open_handler( ttk_menu_item * item );
PzWindow * mikmodule_open_playlist_handler( ttk_menu_item * item );
PzWindow * mikmodule_open_playlist_shuffled_handler( ttk_menu_item * item );


/* _launch
 *	just a menu hook/launcher to start the specific playlist file
 */
PzWindow *mikmodule_launch( ttk_menu_item * mi );


/* _add_playlists_to_menu
 *	scan through the PLAYLIST_LAUNCHABLE list, and add all nodes into
 *	the podzilla2 menu structure in /Music/Playlists/xxx (MikModule)
 */
void mikmodule_add_playlists_to_menu( void );


/* _scan_add_playlist
 *	add a playlist <dirpath>/<di>
 *	This creates the nodes in the PLAYLIST_LAUNCHABLE list in the global
 */
void mikmodule_scan_add_playlist( char * dirpath, struct dirent * di );


/* _scan_playlists_directory
 *	check the passed in directory for any playlist files
 *	if one was found, add it (above)
 */
void mikmodule_scan_playlists_directory( char * dirpath );


/* _scan_playlists
 * 	scan the various directories through the above function
 */
void mikmodule_scan_playlists( void );
