/* Version.h
 *
 *      (c)2007 Scott Lawrence
 *	   yorgle@gmail.com
 */

/*
 * Copyright (C) 2007 Scott Lawrence
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#define MIKMODULE_VERSION       "1.5"  /* for the displays */

/*
----------------------------------------------------------------------------------------------------
NOTE: you probably want to have your terminal be 100 characters wide.

	TO-DO:

		- render.c: clean up the dots/horiz bar code
		- playlist.c: Smart Buffering - multiple file queueing
		- "Loading" screen - hard to put in since the music update is in the timer.


--------------------------------------------------------------------------------
    Release 1.5: 2007-Nov-25
	Bugfix:
		- numitems in render.c was incorrect - now just compute it 
		- fixed a bunch of potential memory issues

	Render:
		- Render item text is expanded a little
		- songpos circles are now rects to speed up things
		- square dots instead of rects, to speed things up on the pod
		- softened the corners of the squares
		- rewrote the managing render function to be a struct of structs
		- added peaks, with peakcolors as a param
		- rewrote pandots to be color-coded, pretty
		- rewrote voice view from scratch.  should be faster
	Views:
		- Kittbars, with brightness background
		- DANCING TUXES!
		- vertical frequency dots
		- Colorshift


--------------------------------------------------------------------------------
    Release 1.4: 2007-Nov-20
	Playlists/Directory Scanning:
	- Playlists can have relative or absolute pathnames in them
	- Added a playlist file scanner - adds entries to the Music menu
	  looks for .mik in:
		/		/mods		/mods/playlists	
		/music		/music/mods	/music/playlists
		/mnt		/mnt/mods	/mnt/mods/playlists
		/mnt/music	/mnt/music/mods	/mnt/music/playlists
		/music/mods/playlists	/mnt/music/mods/playlists
	- Added SymPlaylists - make a symlink.mik to a directory
	- fixed false positive file OK with directories named XM, etc
	Errors:
	- Added better error reporting for failed files
	- Added better error reporting for failed playlists/directories
	- Added auto-quit on >8 consecutive load errors
	- Setting: Added autodismissal to error boxes
	Function:
	- Heuristics added.  Just one for now:
		- disable panning for the mod "testlast"
	- Volume stepping gets finer at lower volumes for 5.5 hopefully
	Visuals:
	- Volume icons for the volume slider
	- Setting: color dots/original FG dots 
	- Setting: color brightness gain for brightness bars
	- Brightness bars 
	- color dots are always playback level
	- voice dots are always waveform amplitude
	- voice dots display on black if color, and are 1/4 screen H
	- Header text cycles info about the track
	Misc:
	- priority set to VITAL, to eliminate sleeping (sorta)
	- Added support for the Settings menu grouping

--------------------------------------------------------------------------------
    Release 1.3: 2007-Jan-?? (Unreleased)
	- pulled out file extension stuff into ext.[ch]
	- used that to help clean up directory-playlist creation
	- moved voiceinfo into glob
	- added bg2 for the voices view - xagruian aragorgon stripes
	- FIX: DerPapst found a volume mode switch bug left/right.
	- have the beginnings of the GUI/timer/poll bits in.  The tradeoff:
		GUI Responsiveness
		vrs. GUI update rate
		vrs. number of voices played-back
		vrs. GUI-playback interference
	  it's time consuming to find numbers that work, and I always listen to
	  4-16 channel songs, so i think I'm going to leave this out for now.
	  search on: __TR__ __TC__
	    IF YOU FIGURE OUT A GOOD CONFIGURATION, LET ME KNOW... I GIVE UP!
	  it seems as though i either end up with:
		a responsive GUI with a sputtery playback engine
		a non-responsive GUI when >26 voices in use, but smooth playback
		low framerate all the time, but decent playback and responsiveness
		- perhaps it needs to be dynamic based on the song playing? hmm...
	- Now using PZ's "VERBOSITY" setting instead of our own
	- Now using PZ's "REPEAT" setting
	- FIX: force the EDIT_VIEW overlay to disappear when we switch to _IDLE
	- hold >> or << to scrub
	- added: rainbow volume bars (Protracker bars)
	- added setting: scootching - if freq or vol go > max, it adjusts the screen
	- render.c: freq dots should line up with voices


--------------------------------------------------------------------------------
    Release 1.2: 2007-Jan-10
	- rewrote the render code to be more modular
	- rewrote the interface to make sense
	- action changes edit modes: volume, scrub, view
 	- Changed the pan dots to be frequency dots (and added freqmax scaling)
	- removed the boxes for the note volume bars
	- browser can now grab entire directories, rather than just playlsits
	- title bar displays playlist pos, and title or filename
	- added "paused" display.
	- added setting: recursion for directories - always, never, ask
	- added setting: Messages - turns off "failed loading a file!"
		-NOTE: change podzilla's "Verbosity" to:
			Errors, Warnings, Information, All, None
		- not always working right - check fail cases to make sure they proceed
	- added lots of views
	- FIX: bad files in a playlist are skipped over now.
	- FIX: ignore first wheel move after >>, << 


--------------------------------------------------------------------------------
    Release 1.1: 2007-Jan-08
  	- separation now only works on 4 channel or fewer mods
	- separation is also adjustable (high, med, low, mono)
	- more playlist extensions supported
	- text display adds pattern pos
	- preliminary multiple-display selector
	- volume bars display
	- pan sliders display
	- shuffle playlist from browser
	- new issue: the control for changing volume/pos needs to be 
	  decoupled from the screen display toggle. (X noted above)


--------------------------------------------------------------------------------
    Release 1.0: 2007-Jan-07
	- basic playback, one boring display screen
	- playlist support
	- known issues:
		- text can overwrite (X re-layed-out the screen)
		- no shuffle (X implemented)
		- on intensive mods (spieg-jewel.xm) 28 voices+samples,
		  it can block gui updates in the mod update loop.
			(X nothing i can do about this)
*/
